package com.progress.print;

import java.util.Properties;

import javax.activation.DataHandler;
import javax.activation.FileDataSource;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Multipart;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;

import org.apache.log4j.Logger;

public class Emailer {
    private static final String MAIL_PROPERTIES_LOCATION = "mail.properties";

    private static final Logger LOGGER = Logger.getLogger(Emailer.class);

    public void sendMail(String[] emails, String subject, String body,
	    String attachment) throws MessagingException {
	Properties props = PropertyLoader
		.loadProperties(MAIL_PROPERTIES_LOCATION);

	LOGGER
		.info("Sending file: " + attachment + " to "
			+ emails.toString());

	Session mailSession = Session.getDefaultInstance(props, null);
	Transport transport = mailSession.getTransport();

	MimeMessage message = new MimeMessage(mailSession);
	message.setSubject(subject);

	MimeBodyPart textPart = new MimeBodyPart();
	textPart.setContent(body, "text/html");

	MimeBodyPart attachFilePart = new MimeBodyPart();
	FileDataSource fds = new FileDataSource(attachment);
	attachFilePart.setDataHandler(new DataHandler(fds));
	attachFilePart.setFileName(fds.getName());

	Multipart mp = new MimeMultipart();
	mp.addBodyPart(textPart);
	mp.addBodyPart(attachFilePart);
	message.setContent(mp);
	for (int i = 0; i < emails.length; i++) {
	    if (i == 0) {
		message.addRecipient(Message.RecipientType.TO,
			new InternetAddress(emails[i]));
	    } else {
		message.addRecipient(Message.RecipientType.CC,
			new InternetAddress(emails[i]));
	    }
	}

	transport.connect();
	transport.sendMessage(message, message
		.getRecipients(Message.RecipientType.TO));
	transport.close();
    }
}
